Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices
Module FastcamDllDriver
    
    '----------------------------
    'CamereControl
    '----------------------------
    Declare Function CameraControl Lib "Pcc4VB.Dll" (ByVal device_select As Integer) As Integer
    Declare Function GetNumberOfDevice Lib "Pcc4VB.Dll" (ByRef number As Integer) As Integer
    Declare Function Init Lib "Pcc4VB.Dll" (ByVal camera_num As Integer) As Integer
    Declare Function ExitCameraControl Lib "Pcc4VB.Dll" () As Integer
    Declare Function IsInit Lib "Pcc4VB.Dll" () As Integer
    Declare Function GetDeviceName Lib "Pcc4VB.Dll" (ByVal name As String) As Integer
    Declare Function GetDeviceType Lib "Pcc4VB.Dll" (ByRef DeviceType As Integer) As Integer
    Declare Function GetDeviceVersion Lib "Pcc4VB.Dll" (ByRef version As Integer) As Integer
    Declare Function GetCameraMode Lib "Pcc4VB.Dll" (ByRef mode As Integer) As Integer
    Declare Function IsColor Lib "Pcc4VB.Dll" (ByRef color As Integer) As Integer
    Declare Function HaveGammaCorrection Lib "Pcc4VB.Dll" (ByRef have As Integer) As Integer
    Declare Function HaveGainLevel Lib "Pcc4VB.Dll" (ByRef have As Integer) As Integer
    Declare Function HaveColorTemperature Lib "Pcc4VB.Dll" (ByRef have As Integer) As Integer
    Declare Function HaveExternalSyncMode Lib "Pcc4VB.Dll" (ByRef have As Integer) As Integer
    Declare Function HaveExternalSyncInMode Lib "Pcc4VB.Dll" (ByRef have As Integer) As Integer
    Declare Function HaveExternalSyncOutMode Lib "Pcc4VB.Dll" (ByRef have As Integer) As Integer
    Declare Function HaveEdgeEnhancement Lib "Pcc4VB.Dll" (ByRef have As Integer) As Integer
    Declare Function HaveZoomMode Lib "Pcc4VB.Dll" (ByRef have As Integer) As Integer
    Declare Function HaveBlockPlay Lib "Pcc4VB.Dll" (ByRef have As Integer) As Integer
    Declare Function HaveExternalInput Lib "Pcc4VB.Dll" (ByRef have As Integer) As Integer
    Declare Function HaveExternalOutput Lib "Pcc4VB.Dll" (ByRef have As Integer) As Integer
    Declare Function HaveMonitorOutMode Lib "Pcc4VB.Dll" (ByRef have As Integer) As Integer
    Declare Function HaveMCDL Lib "Pcc4VB.Dll" (ByRef have As Integer) As Integer
    Declare Function HaveIRIG Lib "Pcc4VB.Dll" (ByRef have As Integer) As Integer
    Declare Function SetCameraParams Lib "Pcc4VB.Dll" (ByRef params As CAMERA_PARAMS) As Integer
    Declare Function SetCameraParamsEx Lib "Pcc4VB.Dll" (ByRef params As CAMERA_PARAMS_EX) As Integer
    Declare Function SetRecordRate Lib "Pcc4VB.Dll" (ByVal Record_rate As Integer) As Integer
    Declare Function SetShutterSpeed Lib "Pcc4VB.Dll" (ByVal speed As Integer) As Integer
    Declare Function SetTriggerMode Lib "Pcc4VB.Dll" (ByVal mode As Integer) As Integer
    Declare Function SetRandomTriggerNumber Lib "Pcc4VB.Dll" (ByVal number As Integer) As Integer
    Declare Function SetManualTriggerPosition Lib "Pcc4VB.Dll" (ByVal position As Integer) As Integer
    Declare Function SetRandomManualPosition Lib "Pcc4VB.Dll" (ByVal position As Integer) As Integer
    Declare Function SetResolution Lib "Pcc4VB.Dll" (ByVal resolution As Integer) As Integer
    Declare Function SetGammaCorrection Lib "Pcc4VB.Dll" (ByVal mode As Integer) As Integer
    Declare Function SetGainLevel Lib "Pcc4VB.Dll" (ByVal mode As Integer) As Integer
    Declare Function SetColorTemperature Lib "Pcc4VB.Dll" (ByVal mode As Integer) As Integer
    Declare Function SetColorTempUser Lib "Pcc4VB.Dll" (ByVal mode As Integer, ByVal r As Integer, ByVal g As Integer, ByVal b As Integer) As Integer
    Declare Function SetExternalSyncMode Lib "Pcc4VB.Dll" (ByVal ModeOn As Integer) As Integer
    Declare Function SetExternalSyncModeEx Lib "Pcc4VB.Dll" (ByVal mode As Integer) As Integer
    Declare Function SetExternalSyncInMode Lib "Pcc4VB.Dll" (ByRef mode As Integer) As Integer
    Declare Function SetExternalSyncOutMode Lib "Pcc4VB.Dll" (ByVal mode As Integer) As Integer
    Declare Function SetEdgeEnhancementMode Lib "Pcc4VB.Dll" (ByVal mode As Integer) As Integer
    Declare Function SetZoomMode Lib "Pcc4VB.Dll" (ByVal ModeOn As Integer) As Integer
    Declare Function SetExternalInMode Lib "Pcc4VB.Dll" (ByVal port As Integer, ByVal mode As Integer) As Integer
    Declare Function SetExternalOutMode Lib "Pcc4VB.Dll" (ByVal port As Integer, ByVal mode As Integer) As Integer
    Declare Function SetMonitorOutMode Lib "Pcc4VB.Dll" (ByVal mode As Integer) As Integer
    Declare Function SetPartition Lib "Pcc4VB.Dll" (ByVal partition_number As Integer) As Integer
    Declare Function SetPartitionBlockList Lib "Pcc4VB.Dll" (ByRef list As Integer, ByVal listSize As Integer) As Integer
    Declare Function SetExtraCommand Lib "Pcc4VB.Dll" (ByVal command_name As Integer, ByVal param1 As Integer, ByVal param2 As Integer, ByVal param3 As Integer, ByVal param4 As Integer) As Integer
    Declare Function GetExtraCommand Lib "Pcc4VB.Dll" (ByVal command_name As Integer, ByRef param1 As Integer, ByRef param2 As Integer, ByRef param3 As Integer, ByRef param4 As Integer) As Integer
    Declare Function GetMaxFrame Lib "Pcc4VB.Dll" (ByRef frame As Integer) As Integer
    Declare Function GetFrameParams Lib "Pcc4VB.Dll" (ByRef params As FRAME_PARAMS) As Integer
    Declare Function GetCameraParams Lib "Pcc4VB.Dll" (ByRef params As CAMERA_PARAMS) As Integer
    Declare Function GetCameraParamsEx Lib "Pcc4VB.Dll" (ByRef params As CAMERA_PARAMS_EX) As Integer
    Declare Function UpdateCameraParams Lib "Pcc4VB.Dll" () As Integer
    Declare Function UpdateCameraParamsEx Lib "Pcc4VB.Dll" () As Integer
    Declare Function GetRecordRate Lib "Pcc4VB.Dll" (ByRef Record_rate As Integer) As Integer
    Declare Function GetShutterSpeed Lib "Pcc4VB.Dll" (ByRef speed As Integer) As Integer
    Declare Function GetTriggerMode Lib "Pcc4VB.Dll" (ByRef mode As Integer) As Integer
    Declare Function GetRandomTriggerNumber Lib "Pcc4VB.Dll" (ByRef number As Integer) As Integer
    Declare Function GetManualTriggerPosition Lib "Pcc4VB.Dll" (ByRef position As Integer) As Integer
    Declare Function GetRandomManualPosition Lib "Pcc4VB.Dll" (ByRef position As Integer) As Integer
    Declare Function GetResolution Lib "Pcc4VB.Dll" (ByRef resolution As Integer) As Integer
    Declare Function GetGammaCorrection Lib "Pcc4VB.Dll" (ByRef mode As Integer) As Integer
    Declare Function GetGainLevel Lib "Pcc4VB.Dll" (ByRef mode As Integer) As Integer
    Declare Function GetColorTemperature Lib "Pcc4VB.Dll" (ByRef mode As Integer) As Integer
    Declare Function GetColorTempUser Lib "Pcc4VB.Dll" (ByVal mode As Integer, ByRef r As Integer, ByRef g As Integer, ByRef b As Integer) As Integer
    Declare Function GetExternalSyncMode Lib "Pcc4VB.Dll" (ByRef ModeOn As Integer) As Integer
    Declare Function GetEdgeEnhancementMode Lib "Pcc4VB.Dll" (ByRef mode As Integer) As Integer
    Declare Function GetZoomMode Lib "Pcc4VB.Dll" (ByRef ModeOn As Integer) As Integer
    Declare Function GetExternalSyncModeEx Lib "Pcc4VB.Dll" (ByRef mode As Integer) As Integer
    Declare Function GetExternalSyncInMode Lib "Pcc4VB.Dll" (ByRef mode As Integer) As Integer
    Declare Function GetExternalSyncOutMode Lib "Pcc4VB.Dll" (ByRef mode As Integer) As Integer
    Declare Function GetExternalInMode Lib "Pcc4VB.Dll" (ByVal port As Integer, ByRef mode As Integer) As Integer
    Declare Function GetExternalOutMode Lib "Pcc4VB.Dll" (ByVal port As Integer, ByRef mode As Integer) As Integer
    Declare Function GetMonitorOutMode Lib "Pcc4VB.Dll" (ByRef mode As Integer) As Integer
    Declare Function GetRecordRateList Lib "Pcc4VB.Dll" (ByRef list As Integer, ByVal listSize As Integer) As Integer
    Declare Function GetShutterSpeedList Lib "Pcc4VB.Dll" (ByRef list As Integer, ByVal listSize As Integer) As Integer
    Declare Function GetTriggerModeList Lib "Pcc4VB.Dll" (ByRef list As Integer, ByVal listSize As Integer) As Integer
    Declare Function GetResolutionList Lib "Pcc4VB.Dll" (ByRef list As Integer, ByVal listSize As Integer) As Integer
    Declare Function GetRandomTriggerNumberList Lib "Pcc4VB.Dll" (ByRef list As Integer, ByVal listSize As Integer) As Integer
    Declare Function GetColorTemperatureList Lib "Pcc4VB.Dll" (ByRef list As Integer, ByVal listSize As Integer) As Integer
    Declare Function GetGainLevelList Lib "Pcc4VB.Dll" (ByRef list As Integer, ByVal listSize As Integer) As Integer
    Declare Function GetGammaCorrectionList Lib "Pcc4VB.Dll" (ByRef list As Integer, ByVal listSize As Integer) As Integer
    Declare Function GetPartitionInfo Lib "Pcc4VB.Dll" (ByRef max_partition As Integer, ByRef max_partition_block As Integer, ByRef frame_per_block As Integer) As Integer
    Declare Function GetPartition Lib "Pcc4VB.Dll" (ByRef partition_number As Integer) As Integer
    Declare Function GetPartitionBlockList Lib "Pcc4VB.Dll" (ByRef list As Integer, ByVal listSize As Integer) As Integer
    Declare Function OnLive Lib "Pcc4VB.Dll" (ByVal LiveOn As Integer) As Integer
    Declare Function IsLive Lib "Pcc4VB.Dll" (ByRef LiveOn As Integer) As Integer
    Declare Function SetCameraNumber Lib "Pcc4VB.Dll" (ByVal number As Integer) As Integer
    Declare Function GetCameraNumber Lib "Pcc4VB.Dll" () As Integer
    Declare Function OnRecordReady Lib "Pcc4VB.Dll" (ByVal RecordReadyOn As Integer) As Integer
    Declare Function OnRecord Lib "Pcc4VB.Dll" (ByVal RecordOn As Integer) As Integer
    Declare Function IsRecordReady Lib "Pcc4VB.Dll" (ByRef RecordReadyOn As Integer) As Integer
    Declare Function IsRecord Lib "Pcc4VB.Dll" (ByRef RecordOn As Integer) As Integer
    Declare Function IsEndlessRec Lib "Pcc4VB.Dll" (ByRef EndlessRecOn As Integer) As Integer
    Declare Function TriggerIn Lib "Pcc4VB.Dll" () As Integer
    Declare Function PlayMonitor Lib "Pcc4VB.Dll" (ByVal mode As Integer) As Integer
    Declare Function PauseMonitor Lib "Pcc4VB.Dll" (ByVal PauseOn As Integer) As Integer
    Declare Function StopMonitor Lib "Pcc4VB.Dll" () As Integer
    Declare Function StepFowardMonitor Lib "Pcc4VB.Dll" () As Integer
    Declare Function StepBackMonitor Lib "Pcc4VB.Dll" () As Integer
    Declare Function GoAnyFrameMonitor Lib "Pcc4VB.Dll" (ByVal frame As Integer) As Integer
    Declare Function GoStartMonitor Lib "Pcc4VB.Dll" () As Integer
    Declare Function GoEndMonitor Lib "Pcc4VB.Dll" () As Integer
    Declare Function GoTriggerMonitor Lib "Pcc4VB.Dll" () As Integer
    Declare Function SetPlayRate Lib "Pcc4VB.Dll" (ByVal Play_rate As Integer) As Integer
    Declare Function SetBlockArea Lib "Pcc4VB.Dll" (ByVal startArea As Integer, ByVal endArea As Integer) As Integer
    Declare Function SetBlockMode Lib "Pcc4VB.Dll" (ByVal ModeOn As Integer) As Integer
    Declare Function GetPlayRate Lib "Pcc4VB.Dll" (ByRef Play_rate As Integer) As Integer
    Declare Function GetBlockArea Lib "Pcc4VB.Dll" (ByRef startArea As Integer, ByRef endArea As Integer) As Integer
    Declare Function GetBlockMode Lib "Pcc4VB.Dll" (ByRef ModeOn As Integer) As Integer
    Declare Function GetTimeCodeFromFrame Lib "Pcc4VB.Dll" (ByRef timecode As IRIGLIB_TIMECODE, ByVal frame As Integer) As Integer
    Declare Function GetDateOfRecording Lib "Pcc4VB.Dll" (ByRef year_at_date As Integer, ByRef month_at_date As Integer, ByRef day_at_date As Integer) As Integer
    Declare Function GetTimeOfRecording Lib "Pcc4VB.Dll" (ByRef hour_at_time As Integer, ByRef minute_at_time As Integer, ByRef second_at_time As Integer) As Integer
	Declare Function GetRandCenterManualFrames Lib "Pcc4VB.Dll" (ByRef Times As Integer, ByRef frame As Integer) As Integer
	Declare Sub GetIICycleRange Lib "Pcc4VB.Dll" (ByRef dwMin As Integer, ByRef dwMax As Integer)
	Declare Sub GetIIWidthRange Lib "Pcc4VB.Dll" (ByRef dwMin As Integer, ByRef dwMax As Integer)
	Declare Sub GetIIDelayRange Lib "Pcc4VB.Dll" (ByRef dwMin As Integer, ByRef dwMax As Integer)
	Declare Sub GetIITimesRange Lib "Pcc4VB.Dll" (ByRef dwMin As Integer, ByRef dwMax As Integer)
	Declare Sub SetIIPowerSafetyParam Lib "Pcc4VB.Dll" (ByVal nBaseValue As Integer, ByRef pValue As Integer, ByVal nMode As Integer, ByVal nEnable As Integer)
    Declare Function TransferFrame Lib "Pcc4VB.Dll" (ByVal frame As Integer, ByRef buff As Byte) As Integer
    Declare Function TransferRawBayer Lib "Pcc4VB.Dll" (ByVal frame As Integer, ByRef buff As Byte) As Integer
    Declare Function Transfer16BitFrame Lib "Pcc4VB.Dll" (ByVal frame As Integer, ByRef buff As Byte) As Integer
    Declare Function Transfer16BitRawBayer Lib "Pcc4VB.Dll" (ByVal frame As Integer, ByRef buff As Byte) As Integer
    Declare Function TransferMCDL Lib "Pcc4VB.Dll" (ByVal frame As Integer, ByRef buff As Byte) As Integer
    Declare Function GetEnableMCDL Lib "Pcc4VB.Dll" (ByRef MCDLOn As Integer) As Integer
    Declare Function SetEnableMCDL Lib "Pcc4VB.Dll" (ByVal MCDLOn As Integer) As Integer
    Declare Function TransferIRIG Lib "Pcc4VB.Dll" (ByVal frame As Integer, ByRef buff As Byte) As Integer
    Declare Function GetEnableIRIG Lib "Pcc4VB.Dll" (ByRef IRIGOn As Integer) As Integer
    Declare Function SetEnableIRIG Lib "Pcc4VB.Dll" (ByVal IRIGOn As Integer) As Integer
    Declare Function ShadingCompensation Lib "Pcc4VB.Dll" () As Integer
    Declare Function GetHeadName Lib "Pcc4VB.Dll" (ByVal name As String, ByVal no As Integer) As Integer
    Declare Function GetVariableRateList Lib "Pcc4VB.Dll" (ByRef list As Integer, ByVal listSize As Integer) As Integer
    Declare Function GetVariableMaxResolution Lib "Pcc4VB.Dll" (ByVal nFrame As Integer, ByRef nWidth As Integer, ByRef nHeight As Integer) As Integer
    Declare Function GetVariableMaxWidth Lib "Pcc4VB.Dll" (ByVal nFrame As Integer, ByVal nHeight As Integer, ByRef nWidth As Integer) As Integer
    Declare Function GetVariableMaxHeight Lib "Pcc4VB.Dll" (ByVal nFrame As Integer, ByVal nWidth As Integer, ByRef nHeight As Integer) As Integer
    Declare Function GetVariableMaxFrameRate Lib "Pcc4VB.Dll" (ByVal nWidth As Integer, ByVal nHeight As Integer, ByRef nRate As Integer) As Integer
    Declare Function GetVariableSetting Lib "Pcc4VB.Dll" (ByVal nChannel As Integer, ByRef nFrameRate As Integer, ByRef nWidth As Integer, ByRef nHeight As Integer, ByRef nXPos As Integer, ByRef nYPos As Integer) As Integer
    Declare Function SetVariableSetting Lib "Pcc4VB.Dll" (ByVal nChannel As Integer, ByVal nFrameRate As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal nXPos As Integer, ByVal nYPos As Integer) As Integer
    Declare Function GetVariableCamMode Lib "Pcc4VB.Dll" (ByRef nMode As Integer, ByRef nChannel As Integer) As Integer
    Declare Function SetGeometricConvert Lib "Pcc4VB.Dll" (ByVal mode As Integer) As Integer
    Declare Function GetGeometricConvert Lib "Pcc4VB.Dll" (ByRef mode As Integer) As Integer
    Declare Function GetShutterSpeedType2List Lib "Pcc4VB.Dll" (ByRef list As Integer, ByVal listSize As Integer) As Integer
    Declare Function GetShutterSpeedType2 Lib "Pcc4VB.Dll" (ByRef speed As Integer) As Integer
    Declare Function SetAutoExposure Lib "Pcc4VB.Dll" (ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal nXPos As Integer, ByVal nYPos As Integer, ByVal nValue As Integer, ByVal nRange As Integer) As Integer
    Declare Function GetAutoExposureArea Lib "Pcc4VB.Dll" (ByRef nWidth As Integer, ByRef nHeight As Integer, ByRef nXPos As Integer, ByRef nYPos As Integer) As Integer
    Declare Function GetAutoExposureParam Lib "Pcc4VB.Dll" (ByRef nValue As Integer, ByRef nRange As Integer) As Integer
    Declare Function GetShutterSpeedAEList Lib "Pcc4VB.Dll" (ByRef list As Integer, ByVal listsize As Integer, ByRef listnum As Integer) As Integer)
    Declare Function SetGEtherConfig Lib "Pcc4VB.Dll", (ByVal PacketSize As Integer, ByVal SendPort As Integer, ByVal ReceivePort As Integer, ByVal ConnectMode As Integer) As Integer
    Declare Function GetGEtherConfig Lib "Pcc4VB.Dll", (ByRef PacketSize As Integer, ByRef SendPort As Integer, ByRef ReceivePort As Integer, ByRef ConnectMode As Integer) As Integer

    '----------------------------
    'ImageData
    '----------------------------
    Declare Function ImageData Lib "Pcc4VB.Dll" () As Integer
    Declare Function InitImageData Lib "Pcc4VB.Dll" (ByVal buffer_size As Integer) As Integer
    Declare Function ExitImageData Lib "Pcc4VB.Dll" () As Integer
    Declare Function SetBmpInfo Lib "Pcc4VB.Dll" (ByRef bmpinfo As BITMAPINFO) As Integer
    Declare Function GetBmpInfo Lib "Pcc4VB.Dll" (ByRef bmpinfo As BITMAPINFO) As Integer
    Declare Sub GetImageSize Lib "Pcc4VB.Dll" (ByRef width As Integer, ByRef height As Integer)
    Declare Function GetWindowsImage Lib "Pcc4VB.Dll" (ByRef image As Byte, ByRef buff As Byte, ByRef bmpinfo As BITMAPINFO) As Integer
    Declare Function GetWindows16BitImage Lib "Pcc4VB.Dll" (ByRef image As Byte, ByRef buff As Byte, ByRef bmpinfo As BITMAPINFO) As Integer
    Declare Function SetImageNumber Lib "Pcc4VB.Dll" (ByVal number As Integer) As Integer
    Declare Function GetImageNumber Lib "Pcc4VB.Dll" () As Integer
    Declare Function SetImageData Lib "Pcc4VB.Dll" (ByRef image As Byte) As Integer
    Declare Function GetImageData Lib "Pcc4VB.Dll" (ByRef image As Byte) As Integer
    Declare Function LoadFile Lib "Pcc4VB.Dll" (ByVal filename As String) As Integer
    Declare Function LoadRawFile Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal size_header As Integer, ByVal width As Integer, ByVal height As Integer, ByVal plane As Integer, ByVal interleave As Integer) As Integer
    Declare Function LoadRawwFile Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal size_header As Integer, ByVal width As Integer, ByVal height As Integer, ByVal plane As Integer, ByVal interleave As Integer) As Integer
    Declare Function SaveFile Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal compress As Integer, ByVal comp_quality As Integer, ByVal ascii As Integer) As Integer
    Declare Function SaveBmpFile Lib "Pcc4VB.Dll" (ByVal filename As String) As Integer
    Declare Function SaveTiffFile Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal compress As Integer) As Integer
    Declare Function SaveJpegFile Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal quality As Integer) As Integer
    Declare Function SavePnmFile Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal ascii As Integer) As Integer
    Declare Function SaveRawFile Lib "Pcc4VB.Dll" (ByVal filename As String) As Integer
    Declare Function SaveRawwFile Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal bit_depth As Integer, ByVal bit_side As Integer, ByRef buff As Byte) As Integer
    Declare Function SavePngFile Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal comp_mode As Integer, ByVal depth As Integer) As Integer
    Declare Function SaveFtifFile Lib "Pcc4VB.Dll" (ByVal filename As String) As Integer
    Declare Function ReAllocateBuffer Lib "Pcc4VB.Dll" (ByVal buffer_size As Integer, ByVal surely As Integer) As Integer
    Declare Function ReAllocate16BitBuffer Lib "Pcc4VB.Dll" (ByVal buffer_size As Integer, ByVal surely As Integer) As Integer
    Declare Function Is16BitImage Lib "Pcc4VB.Dll" () As Integer

    Declare Sub InitLut Lib "Pcc4VB.Dll" ()
    Declare Sub SetUseLut Lib "Pcc4VB.Dll" (ByVal UseLutOn As Integer)
    Declare Function GetUseLut Lib "Pcc4VB.Dll" () As Integer
    Declare Sub SetLutR Lib "Pcc4VB.Dll" (ByRef lut As Integer)
    Declare Sub SetLutG Lib "Pcc4VB.Dll" (ByRef lut As Integer)
    Declare Sub SetLutB Lib "Pcc4VB.Dll" (ByRef lut As Integer)
    Declare Sub GetLutR Lib "Pcc4VB.Dll" (ByRef lut As Integer)
    Declare Sub GetLutG Lib "Pcc4VB.Dll" (ByRef lut As Integer)
    Declare Sub GetLutB Lib "Pcc4VB.Dll" (ByRef lut As Integer)
    Declare Sub SetLut Lib "Pcc4VB.Dll" (ByRef lut As Integer, ByVal plane As Integer)
    Declare Sub GetLut Lib "Pcc4VB.Dll" (ByRef lut As Integer, ByVal plane As Integer)
    Declare Sub SetLutGamma Lib "Pcc4VB.Dll" (ByVal gamma As Double, ByVal plane As Integer)
    Declare Sub SetLutContrast Lib "Pcc4VB.Dll" (ByVal contrast As Integer, ByVal plane As Integer)
    Declare Sub SetLutBrightness Lib "Pcc4VB.Dll" (ByVal brightness As Integer, ByVal plane As Integer)
    Declare Function GetLutGamma Lib "Pcc4VB.Dll" (ByVal plane As Integer) As Double
    Declare Function GetLutContrast Lib "Pcc4VB.Dll" (ByVal plane As Integer) As Integer
    Declare Function GetLutBrightness Lib "Pcc4VB.Dll" (ByVal plane As Integer) As Integer
    Declare Function SaveTiffFileEx Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal compress As Integer, ByVal depth As Integer) As Integer

    Structure CAMERA_PARAMS
        Dim enable_random_trigger As Integer
        Dim enable_manual_trigger As Integer
        Dim enable_random_manual As Integer
        Dim enable_gamma As Integer
        Dim enable_gain As Integer
        Dim enable_external_sync As Integer
        Dim enable_external_sync_in As Integer
        Dim enable_external_sync_out As Integer
        Dim enable_external_in As Integer
        Dim enable_external_out As Integer
        Dim enable_color_temp As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> Dim camera_type() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> Dim device_name() As Byte
        Dim device_type As Integer
        Dim device_version As Integer
        Dim color As Integer
        Dim session_number As Integer
        Dim max_frame_num As Integer
        Dim camera_mode As Integer
        Dim is_live As Integer
        Dim is_record_ready As Integer
        Dim Record_rate As Integer
        Dim resolution As Integer
        Dim shutter_speed As Integer
        Dim trigger_mode As Integer
        Dim trigger_frame As Integer
        Dim random_trigger_num As Integer
        Dim manual_trigger_frame As Integer
        Dim random_trigger_times As Integer
        Dim max_random_times As Integer
        Dim random_manual_frame As Integer
        Dim twostage_lowtohigh_frame As Integer
        Dim twostage_hightolow_frame As Integer
        Dim twostage_lowtohigh_timing As Integer
        Dim gamma_value As Integer
        Dim gain_level As Integer
        Dim external_sync As Integer
        Dim external_sync_nega As Integer
        Dim color_temp_mode As Integer
        Dim external_sync_in As Integer
        Dim external_sync_out As Integer
        Dim record_rate_num As Integer
        Dim resolution_num As Integer
        Dim shutter_num As Integer
        Dim trigger_mode_num As Integer
        Dim random_number_num As Integer
        Dim external_in_num As Integer
        Dim external_out_num As Integer
        Dim color_temp_mode_num As Integer
        Dim color_temp_user_num As Integer
        Dim gain_level_num As Integer
        Dim gamma_value_num As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> Dim record_rate_list() As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> Dim resolution_list() As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> Dim shutter_list() As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> Dim trigger_mode_list() As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> Dim random_number_list() As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> Dim external_in() As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> Dim external_out() As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> Dim color_temp_mode_list() As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=128)> Dim color_temp_user() As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> Dim gain_level_list() As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> Dim gamma_value_list() As Integer
        Dim enable_mcdl As Integer
        Dim enable_monitor_out As Integer
        Dim enable_monitor_out_mode As Integer
        Dim enable_monitor_edge As Integer
        Dim enable_monitor_zoom As Integer
        Dim enable_irig As Integer
        Dim enable_restriction_time As Integer
        Dim monitor_block_on As Integer
        Dim monitor_block_start As Integer
        Dim monitor_block_end As Integer
        Dim monitor_play_rate As Integer
        Dim monitor_out_mode As Integer
        Dim monitor_edge_mode As Integer
        Dim monitor_zoom_on As Integer
        Dim mcdl_on As Integer
        Dim irig_on As Integer
        Dim restriction_time_on As Integer
        Dim exist_variablefunc As Integer
        Dim variable_channel As Integer
        Dim save_step As Integer

        Public Sub Initialize()
            ReDim camera_type(63)
            ReDim device_name(63)
            ReDim record_rate_list(LIST_MAX_NUMBER - 1)
            ReDim resolution_list(LIST_MAX_NUMBER - 1)
            ReDim shutter_list(LIST_MAX_NUMBER - 1)
            ReDim trigger_mode_list(LIST_MAX_NUMBER - 1)
            ReDim random_number_list(LIST_MAX_NUMBER - 1)
            ReDim external_in(LIST_MAX_NUMBER - 1)
            ReDim external_out(LIST_MAX_NUMBER - 1)
            ReDim color_temp_mode_list(LIST_MAX_NUMBER - 1)
            ReDim color_temp_user(LIST_MAX_NUMBER *2- 1)
            ReDim gain_level_list(LIST_MAX_NUMBER - 1)
            ReDim gamma_value_list(LIST_MAX_NUMBER - 1)
        End Sub
    End Structure

    Structure CAMERA_PARAMS_EX
        Dim exist_mcdl As Integer
        Dim exist_monitor_out As Integer
        Dim exist_monitor_out_mode As Integer
        Dim exist_monitor_edge As Integer
        Dim exist_monitor_zoom As Integer
        Dim exist_irig As Integer
        Dim exist_restriction_time As Integer
        Dim exist_pdc As Integer
        Dim exist_device_id As Integer
        Dim exist_reset_trigger As Integer
        Dim exist_sensor_bitshift As Integer
        Dim exist_partition As Integer
        Dim exist_geometric_conversion As Integer
        Dim exist_shading_compensation As Integer
        Dim exist_live_resolution As Integer
        Dim exist_lut_mode As Integer
        Dim exist_user_lut As Integer
        Dim exist_chroma_mode As Integer
        Dim exist_ds_shutter As Integer
        Dim monitor_block_on As Integer
        Dim monitor_block_start As Integer
        Dim monitor_block_end As Integer
        Dim monitor_play_rate As Integer
        Dim monitor_out_mode As Integer
        Dim monitor_edge_mode As Integer
        Dim monitor_zoom_on As Integer
        Dim mcdl_on As Integer
        Dim irig_on As Integer
        Dim restriction_time_on As Integer
        Dim pdc_on As Integer
        Dim device_id As Integer
        Dim reset_trigger_on As Integer
        Dim sensor_bitshift As Integer
        Dim max_partition_num As Integer
        Dim max_partition_block_num As Integer
        Dim partition_frame_per_block As Integer
        Dim current_partition As Integer
        Dim partition_num As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=256)> Dim partition_size_list() As Integer
        Dim geometric_conversion_mode As Integer
        Dim shading_compensation_mode As Integer
        Dim live_resolution_mode As Integer
        Dim lut_mode As Integer
        Dim chroma_mode As Integer
        Dim ds_shutter As Integer
        Dim irig_offset As Integer
        Dim exist_irig_offset As Integer
        Dim	exist_hard_partition As Integer
        Dim	hard_partition As Integer
        Dim	II_POWER_ON As Integer
        Dim	II_gain As Integer
        Dim	II_gate_select As Integer
        Dim	II_gate_cycle As Integer
        Dim	II_gate_width As Integer
        Dim	II_gate_times As Integer
        Dim	II_gate_delay As Integer
        Dim	II_gain_limit As Integer
        Dim	exist_ii As Integer
        Dim	shutter_mode As Integer
        Dim	exist_shutter_mode As Integer
        Dim	exist_event_frame As Integer
        Dim	head_total_num As Integer
        Dim	current_head As Integer
        Dim	exist_edge_enhancement As Integer
        Dim	edge_enhancement As Integer
        Dim	exist_shutter_type2 As Integer
        Dim	shutter_speed_type2 As Integer
        Dim	color_matrix_rr As Integer
        Dim	color_matrix_rg As Integer
        Dim	color_matrix_rb As Integer
        Dim	color_matrix_gr As Integer
        Dim	color_matrix_gg As Integer
        Dim	color_matrix_gb As Integer
        Dim	color_matrix_br As Integer
        Dim	color_matrix_bg As Integer
        Dim	color_matrix_bb As Integer
        Dim	exist_color_matrix As Integer
        Dim	color_matrix As Integer
        Dim	exist_auto_exposure As Integer
        Dim	auto_exposure As Integer
        Dim	auto_exposure_reso As Integer
        Dim	auto_exposure_pos As Integer
        Dim	auto_exposure_value As Integer
        Dim	auto_exposure_range As Integer
        Dim	auto_exposure_maxshutter As Integer
        Dim	exist_ii_protection As Integer
        Dim	II_protection As Integer

        Public Sub Initialize()
            ReDim partition_size_list(255)
        End Sub

        Public Sub Initialize()
            ReDim shutter_type2_list(LIST_MAX_NUMBER - 1)
        End Sub
    End Structure

    Structure FRAME_PARAMS
        Dim frame_start As Integer
        Dim frame_end As Integer
        Dim frame_total As Integer
        Dim area_start As Integer
        Dim area_end As Integer
        Dim area_total As Integer
        Dim current As Integer
        Dim trigger As Integer
        Dim key As Integer
    End Structure

    Structure TIME_PARAMS
        Dim time_start As Double
        Dim time_end As Double
        Dim time_total As Double
        Dim area_start As Double
        Dim area_end As Double
        Dim area_total As Double
        Dim current As Double
        Dim trigger As Double
        Dim key As Double
    End Structure

    Structure MCDL_PARAMS
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=11)> Dim digital() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=11)> Dim analog_a() As Single
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=11)> Dim analog_b() As Single
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=11)> Dim analog_c() As Single
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=11)> Dim analog_d() As Single

        Public Sub Initialize()
            ReDim digital(10)
            ReDim analog_a(10)
            ReDim analog_b(10)
            ReDim analog_c(10)
            ReDim analog_d(10)
        End Sub
    End Structure

    Structure IRIGLIB_TIMECODE
        Dim year_Renamed As Integer
        Dim month_Renamed As Byte
        Dim day_Renamed As Byte
        Dim day_of_year As Integer
        Dim hour_Renamed As Byte
        Dim minute_Renamed As Byte
        Dim second_Renamed As Byte
        Dim below_second As Integer
    End Structure

    Structure tagBITMAPINFOHEADER
        Dim biSize As Integer
        Dim biWidth As Integer
        Dim biHeight As Integer
        Dim biPlanes As Short
        Dim biBitCount As Short
        Dim biCompression As Integer
        Dim biSizeimage As Integer
        Dim biXPelsPerMeter As Integer
        Dim biYPelsPerMeter As Integer
        Dim biClrUsed As Integer
        Dim biClrImportant As Integer
    End Structure


    Structure tagRGBQUAD
        Dim rgbBlue As Byte
        Dim rgbGreen As Byte
        Dim rgbRed As Byte
        Dim rgbReserved As Byte
    End Structure

    Structure BITMAPINFO
        Dim BitmapInfoHeader As tagBITMAPINFOHEADER
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=1024)> Dim rgbquad() As Byte
        Public Sub Initialize()
            ReDim rgbquad(1023)
        End Sub
    End Structure

    Structure TM
        Dim tm_sec As Integer   
        Dim tm_min As Integer   
        Dim tm_hour As Integer  
        Dim tm_mday As Integer  
        Dim tm_mon As Integer   
        Dim tm_year As Integer  
        Dim tm_wday As Integer  
        Dim tm_yday As Integer  
        Dim tm_isdst As Integer 
    End Structure

    Public Const EXTRA_SET_MONITOROUT_MODE As Integer = 0
    Public Const EXTRA_GET_MONITOROUT_MODE As Integer = 1
    Public Const EXTRA_SET_MONITOROUT_EDGEENHANCE As Integer = 2
    Public Const EXTRA_GET_MONITOROUT_EDGEENHANCE As Integer = 3
    Public Const EXTRA_SET_MONITOROUT_ZOOM As Integer = 4
    Public Const EXTRA_GET_MONITOROUT_ZOOM As Integer = 5
    Public Const EXTRA_SET_MONITOROUT_DISP_STATUS As Integer = 6
    Public Const EXTRA_GET_MONITOROUT_DISP_STATUS As Integer = 7
    Public Const EXTRA_MONITOROUT_PLAY As Integer = 8
    Public Const EXTRA_MONITOROUT_PAUSE As Integer = 9
    Public Const EXTRA_MONITOROUT_STOP As Integer = 10
    Public Const EXTRA_MONITOROUT_STEP_FOWARD As Integer = 11
    Public Const EXTRA_MONITOROUT_STEP_BACK As Integer = 12
    Public Const EXTRA_MONITOROUT_GOTO_ANYFRAME As Integer = 13
    Public Const EXTRA_MONITOROUT_GOTO_STARY As Integer = 14
    Public Const EXTRA_MONITOROUT_GOTO_END As Integer = 15
    Public Const EXTRA_MONITOROUT_GOTO_TRIGGER As Integer = 16
    Public Const EXTRA_SET_ENABLE_MCDL As Integer = 17
    Public Const EXTRA_GET_ENABLE_MCDL As Integer = 18
    Public Const EXTRA_SET_ENABLE_IRIG As Integer = 19
    Public Const EXTRA_GET_ENABLE_IRIG As Integer = 20
    Public Const EXTRA_SET_ENABLE_PDC As Integer = 21
    Public Const EXTRA_GET_ENABLE_PDC As Integer = 22
    Public Const EXTRA_SET_ENABLE_RESTRICTION_TIME As Integer = 23
    Public Const EXTRA_GET_ENABLE_RESTRICTION_TIME As Integer = 24
    Public Const EXTRA_GET_RESTRICTION_TIME As Integer = 25
    Public Const EXTRA_TRANSFER_MCDL As Integer = 26
    Public Const EXTRA_TRANSFER_IRIG As Integer = 27
    Public Const EXTRA_SHADING_COMPENSATION As Integer = 28
    Public Const EXTRA_GET_CAMERA_ID As Integer = 29
    Public Const EXTRA_SET_CAMERA_ID As Integer = 30
    Public Const EXTRA_GET_ENABLE_RESET_TRIGGER As Integer = 31
    Public Const EXTRA_SET_ENABLE_RESET_TRIGGER As Integer = 32
    Public Const EXTRA_GET_SENSOR_BITSHIFT As Integer = 33
    Public Const EXTRA_SET_SENSOR_BITSHIFT As Integer = 34
    Public Const EXTRA_GET_MAX_PARTITION As Integer = 35
    Public Const EXTRA_GET_PARTITION As Integer = 36
    Public Const EXTRA_SET_PARTITION As Integer = 37
    Public Const EXTRA_GET_PARTITION_LIST As Integer = 38
    Public Const EXTRA_SET_PARTITION_LIST As Integer = 39
    Public Const EXTRA_SET_LIVE_RESOLUTION As Integer = 40
    Public Const EXTRA_GET_LIVE_RESOLUTION As Integer = 41
    Public Const EXTRA_SET_LUT_MODE As Integer = 42
    Public Const EXTRA_GET_LUT_MODE As Integer = 43
    Public Const EXTRA_SET_USER_LUT_PARAMS As Integer = 44
    Public Const EXTRA_GET_USER_LUT_PARAMS As Integer = 45
    Public Const EXTRA_SET_USER_LUT_DATA As Integer = 46
    Public Const EXTRA_GET_USER_LUT_DATA As Integer = 47
    Public Const EXTRA_UPLOAD_USER_LUT As Integer = 48
    Public Const EXTRA_SET_CHROMA_MODE As Integer = 49
    Public Const EXTRA_GET_CHROMA_MODE As Integer = 50
    Public Const EXTRA_SET_DS_SHUTTER_MODE As Integer = 51
    Public Const EXTRA_GET_DS_SHUTTER_MODE As Integer = 52
    Public Const EXTRA_SET_INTERFACE_INFO As Integer = 53
    Public Const EXTRA_GET_INTERFACE_INFO As Integer = 54
    Public Const EXTRA_SET_SHADING_MODE As Integer = 55
    Public Const EXTRA_GET_SHADING_MODE As Integer = 56
    Public Const EXTRA_GET_SHADING_LOCK As Integer = 57
    Public Const EXTRA_TRANSFER_MCDLIRIG_STREAM As Integer = 58
	Public Const EXTRA_SET_IRIG_OFFSET As Integer = 59
	Public Const EXTRA_GET_IRIG_OFFSET As Integer = 60
	Public Const EXTRA_SET_HARD_PARTITION As Integer = 61
	Public Const EXTRA_GET_HARD_PARTITION As Integer = 62
	Public Const EXTRA_GET_HEAD_INFO As Integer = 63
	Public Const EXTRA_GET_HEAD_EXCHANGE As Integer = 64
	Public Const EXTRA_GET_HEAD_NAME As Integer = 65
	Public Const EXTRA_SET_SHUTTER_MODE As Integer = 66
	Public Const EXTRA_GET_SHUTTER_MODE As Integer = 67
	Public Const EXTRA_SET_II_POWER As Integer = 68
	Public Const EXTRA_GET_II_POWER As Integer = 69
	Public Const EXTRA_SET_II_GAIN As Integer = 70
	Public Const EXTRA_GET_II_GAIN As Integer = 71
	Public Const EXTRA_SET_II_GATE_SELECT As Integer = 72
	Public Const EXTRA_GET_II_GATE_SELECT As Integer = 73
	Public Const EXTRA_SET_II_GATE_CYCLE As Integer = 74
	Public Const EXTRA_GET_II_GATE_CYCLE As Integer = 75
	Public Const EXTRA_SET_II_GATE_WIDTH As Integer = 76
	Public Const EXTRA_GET_II_GATE_WIDTH As Integer = 77
	Public Const EXTRA_SET_II_GATE_TIMES As Integer = 78
	Public Const EXTRA_GET_II_GATE_TIMES As Integer = 79
	Public Const EXTRA_SET_II_GATE_DELAY As Integer = 80
	Public Const EXTRA_GET_II_GATE_DELAY As Integer = 81
	Public Const EXTRA_GET_II_GAIN_LIMIT As Integer = 82
	Public Const EXTRA_GET_EVENT_FRAME As Integer = 84
	Public Const EXTRA_SET_VARIABLE_SAVE As Integer = 85
	Public Const EXTRA_SET_VARIABLE_LOAD As Integer = 86
	Public Const EXTRA_SET_VARIABLE_ERASE As Integer = 87
	Public Const EXTRA_GET_II_GATE_WIDTH_LIMIT As Integer = 88
	Public Const EXTRA_SET_PIXEL_GAIN As Integer = 89
	Public Const EXTRA_GET_PIXEL_GAIN As Integer = 90
	Public Const EXTRA_SET_EDGE_ENHANCEMENT As Integer = 91
	Public Const EXTRA_GET_EDGE_ENHANCEMENT As Integer = 92
	Public Const EXTRA_SET_COLOR_MATRIX As Integer = 93
	Public Const EXTRA_GET_COLOR_MATRIX As Integer = 94
	Public Const EXTRA_SET_AUTO_EXPOSURE As Integer = 95
	Public Const EXTRA_GET_AUTO_EXPOSURE As Integer = 96
	Public Const EXTRA_SET_AUTO_EXPOSURE_MAXSHUTTER As Integer = 97
	Public Const EXTRA_GET_AUTO_EXPOSURE_MAXSHUTTER As Integer = 98
	Public Const EXTRA_GET_1FRAME_TIME As Integer = 99
	Public Const EXTRA_SET_II_PROTECTION As Integer = 100
	Public Const EXTRA_GET_II_PROTECTION As Integer = 101
End Module
